/**
 * @license
 * Copyright 2017 JBoss Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { ChangeDetectorRef } from "@angular/core";
import { ICommand, OasDocument, OasParameter, OasPathItem, SimplifiedParameterType } from "apicurio-data-models";
import { SourceFormComponent } from "./source-form.base";
import { ClonePathDialogComponent } from "../dialogs/clone-path.component";
import { AddPathDialogComponent } from "../dialogs/add-path.component";
import { RenamePathDialogComponent } from "../dialogs/rename-path.component";
import { SelectionService } from "../../_services/selection.service";
import { CommandService } from "../../_services/command.service";
import { DocumentService } from "../../_services/document.service";
import { EditorsService } from "../../_services/editors.service";
export declare class PathFormComponent extends SourceFormComponent<OasPathItem> {
    protected changeDetectorRef: ChangeDetectorRef;
    protected selectionService: SelectionService;
    protected commandService: CommandService;
    protected documentService: DocumentService;
    private editors;
    protected _path: OasPathItem;
    set path(path: OasPathItem);
    get path(): OasPathItem;
    clonePathDialog: ClonePathDialogComponent;
    addPathDialog: AddPathDialogComponent;
    renamePathDialog: RenamePathDialogComponent;
    constructor(changeDetectorRef: ChangeDetectorRef, selectionService: SelectionService, commandService: CommandService, documentService: DocumentService, editors: EditorsService);
    protected createEmptyNodeForSource(): OasPathItem;
    protected createReplaceNodeCommand(node: OasPathItem): ICommand;
    document(): OasDocument;
    is3xDocument(): boolean;
    delete(): void;
    newPath(): void;
    addPath(path: string): void;
    clone(modalData?: any): void;
    rename(modalData?: any): void;
    hasParameters(type: string): boolean;
    parameters(paramType: string): OasParameter[];
    changeParamDescription(param: OasParameter, newParamDescription: string): void;
    changeParamType(param: OasParameter, newType: SimplifiedParameterType): void;
    deleteParam(parameter: OasParameter): void;
    enableSourceMode(): void;
}
